#ifndef DESKVIEW_H
#define DESKVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>

#include <glob.h>
#include <limits.h>
#include <memory.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <ctype.h>
#ifdef HAVE_LIBXFCEGUI4
#include <libxfcegui4/libxfcegui4.h>
#endif


#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <gdk/gdkx.h>
#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gmodule.h>
#include <dbh.h>

#include "types.h"
#include "constants.h"

#include "primary.h"
#include "gui.h"
#include "actions_lib.h"

#include "deskview_types.h"
#include "deskview_macros.h"
#include "deskview_popup.h"
#include "deskview_lib.h"
int 
reload_deskview(desk_view_t *deskview_p);
#define DESKVIEW_GEOMETRY_DBH_FILE "xffm","deskview_geometry.dbh"
int deskview_runit(widgets_t *widgets_p, int argc, gchar **argv, gboolean internal);
#endif
