#include <gdk/gdkkeysyms.h>
extern 
void treeview_touch_activate(GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_duplicate_activate (GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_rename_activate(GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_symlink_activate(GtkMenuItem * menuitem, gpointer user_data);


static
void sb_duplicate(GtkWidget *w){
    treeview_duplicate_activate((GtkMenuItem *)w,NULL);
}
static
void sb_symlink(GtkWidget *w){
    treeview_symlink_activate((GtkMenuItem *)w,NULL);
}
static
void sb_touch(GtkWidget *w){
    treeview_touch_activate((GtkMenuItem *)w,NULL);
}
static
void sb_rename(GtkWidget *w){
    treeview_rename_activate((GtkMenuItem *)w,NULL);
}
static
void sb_scramble(GtkWidget *w){
    on_scramble_activate((GtkMenuItem *)w,NULL);
}
static
void sb_unscramble(GtkWidget *w){
    on_unscramble_activate((GtkMenuItem *)w,NULL);
}


    smart_button_init_t exec_button_info[]={
      {"xffm/stock_terminal",N_("Terminal"),on_term,"sb_term",NULL,NULL,(gpointer)on_open_in_terminal_activate,GDK_T},
      {"xffm-iconview",N_("Icon view"),sb_iconview,"sb_iconview",NULL,NULL,(gpointer)on_iconview_activate,GDK_J},
      {"xffm/stock_run",N_("Run"),sb_run,"sb_run",NULL,NULL,(gpointer)treeview_run_activate,GDK_E},
      {"xffm/stock_search",N_("Find"),sb_find,"sb_find",NULL,NULL,(gpointer)on_find_activate,GDK_F},
      {"xfdiff-icon",N_("Differences"),sb_diff,NULL,NULL,NULL,(gpointer)on_differences_activate,GDK_H},
      {"xffm/stock_print-preview",N_("Printer configuration"),sb_printer_configuration,NULL,NULL,NULL,(gpointer)on_printer_configuration_activate,0},
      {"xffm/stock_justify-fill",N_("List Pasteboard"),sb_list_pasteboard,NULL,NULL,NULL,(gpointer)treeview_list_pasteboard_activate,GDK_L},
      {"xffm/stock_clear",N_("Clear Pasteboard"),sb_clear_pasteboard,NULL,NULL,NULL,(gpointer)treeview_clear_pasteboard_activate,GDK_K},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };

    smart_button_init_t go_button_info[]={
      {"xffm/stock_jump-to",N_("Go to"),goto_jump,"sb_goto_jump",NULL,NULL,(gpointer)on_jump_to2_activate,GDK_Down},
      {"xffm/stock_home",N_("Home"),go_home,"sb_go_home",NULL,NULL,(gpointer)on_home3_activate,GDK_Home},
      {"xffm/stock_go-back",N_("Back"),go_backward,"sb_go_backward",NULL,NULL,(gpointer)on_back2_activate,GDK_Left},
      {"xffm/stock_go-forward",N_("Forward"),go_forward,"sb_go_forward",NULL,NULL,(gpointer)on_forward2_activate,GDK_Right},
      {"xffm/stock_go-up",N_("Up"),go_up,"sb_go_up",NULL,NULL,(gpointer)on_up2_activate,GDK_Up},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };

    smart_button_init_t view_button_info[]={
      {"xfmime-edit-icon",N_("Customize icons"),sb_xfmime_edit,"sb_xfmime_edit",NULL,NULL,NULL,0},
#ifdef FOOL_INTL
     {"xffm/stock_zoom-in",N_("Enlarge icons"),sb_zoom_in,"sb_zoom_in",NULL,NULL,(gpointer)on_zoom_in_activate,0},
     {"xffm/stock_zoom-out",N_("Shrink icons"),sb_zoom_out,"sb_zoom_out",NULL,NULL,(gpointer)on_zoom_out_activate,0},
#endif
      {"xffm/stock_preferences","settings-show",sb_settings_show,"settings_show",NULL,NULL,(gpointer)on_settings_show,0},
      {"xffm/stock_about",N_("About"),sb_about,"sb_about",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t new_button_info[]={
      {"xffm/stock_properties",N_("Properties"),tb_properties,"sb_properties",NULL,NULL,NULL,0},
      /*{"xffm/stock_new-tab",N_("New file"),tb_new,"sb_new_file",NULL,NULL,(gpointer)on_tb_new,0},*/
      {"xffm/stock_new-tab",N_("New file"),tb_new,"sb_new_file",NULL,NULL,NULL,0},
      /*{"xffm/stock_new-dir",N_("New directory"),tb_newd,"sb_new_dir",NULL,NULL,(gpointer)on_tb_newd,0},*/
      {"xffm/stock_new-dir",N_("New directory"),tb_newd,"sb_new_dir",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    
     smart_button_init_t single_selection_button_info[]={
      {"xffm/stock_print",N_("Print"),tb_print,"sb_print",NULL,NULL,NULL,0},
      {"xffm/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,NULL,0},
      {"xffm/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,NULL,0},
      {"xffm/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,NULL,0},
      {"xffm/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,NULL,0},
      {"emblem-noread",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,NULL,0},
      {"emblem-fun",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
  
#if 0
     smart_button_init_t single_selection_button_info[]={
      {"xffm/stock_print",N_("Print"),tb_print,"sb_print",NULL,NULL,NULL,0},
      /*{"gtk-print",N_("Print"),tb_print,"sb_print","xfprint4",NULL,(gpointer)on_print_activate,GDK_P},*/
      /*{"gtk-print",N_("Print"),run_noterm,"sb_print","xfprint4",NULL,(gpointer)on_print_activate,GDK_P}, This enables dnd to the button but screws up normal button 
      pressing. Should check if run_noterm is still necessary now. */
      /*{"xffm/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,on_duplicate_activate,GDK_D},*/
      {"xffm/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,NULL,0},
      /*{"xffm/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,(gpointer)on_symlink_activate,GDK_S},*/
      {"xffm/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,NULL,0},
      /*{"xffm/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,(gpointer)private_touch_activate,GDK_M},*/
      {"xffm/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,NULL,0},
      /*{"xffm/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,(gpointer)on_rename_activate,GDK_R},*/
      {"xffm/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,NULL,0},
      /*{"xffm/stock_no",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,(gpointer)on_scramble_activate,0},*/
      {"xffm/stock_no",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,NULL,0},
      /*{"xffm/stock_yes",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,(gpointer)on_unscramble_activate,0},*/
      {"xffm/stock_yes",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };

#endif
  
    smart_button_init_t normal_button_info1[]={
      /* this is how to chuck in a separator */
      {"-","-",NULL,NULL,NULL,NULL,NULL},
      {"xffm/stock_cut",N_("Cut"),tb_cut,"nb_cut",NULL,NULL,NULL,0},
      {"xffm/stock_copy",N_("Copy"),tb_copy,"nb_copy",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t paste_button_info[]={
      {"xffm/stock_paste",N_("Paste"),tb_paste,"nb_paste",NULL,NULL,NULL,0},
      {"xffm/stock_pastelink",N_("Symlink"),tb_pastelink,"nb_pastelink",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t normal_button_info1b[]={
      {"xffm/stock_delete",N_("Remove"),tb_delete,"nb_remove",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t normal_button_info2[]={
      {"-","-",NULL,NULL,NULL,NULL,NULL},
      {"xffm/stock_refresh",N_("Refresh"),sb_refresh,"nb_refresh",NULL,NULL,NULL,GDK_Z},
      {"xffm/stock_quit",N_("Quit"),on_tb_off,"nb_close",NULL,NULL,NULL,GDK_Q},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    
    smart_button_init_t popup_button_info[]={
      {"xffm/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate2",NULL,NULL,(gpointer)treeview_duplicate_activate,0},
      {"xffm/stock_cut",N_("Cut"),tb_cut,"cut1",NULL,NULL,(gpointer)treeview_cut_activate,GDK_X},
      {"xffm/stock_copy",N_("Copy"),tb_copy,"copy1",NULL,NULL,(gpointer)treeview_copy_activate,GDK_C},
      {"xffm/stock_paste",N_("Paste"),tb_paste,"paste1",NULL,NULL,(gpointer)treeview_paste_activate,GDK_V},
#ifdef FOOL_INTL
      {"xffm/stock_open",N_("Open book"),NULL,"open_book2",NULL,NULL,(gpointer)on_open_book_activate,GDK_B},
      {"xffm/stock_open",N_("Default book"),NULL,"default_book2",NULL,NULL,(gpointer)on_defaultbook_activate,0},
      {"xffm/stock_question",N_("List books"),NULL,"remember1",NULL,NULL,(gpointer)on_rememberbook_activate,0},
      {"xffm/stock_new-tab",N_("New book"),NULL,"new4",NULL,NULL,(gpointer)on_newbook_activate,0},
      {"xffm/stock_save-as",N_("Save book"),NULL,"save_book2",NULL,NULL,(gpointer)on_save_book,0},
      {"xffm/stock_sort-ascending",N_("Purge"),NULL,"purge_bookmarks1",NULL,NULL,(gpointer)on_purge_bookmarks1_activate,0},
      {"xffm/stock_clear",N_("Clear"),NULL,"clear_all_bookmarks",NULL,NULL,(gpointer)on_clear_all_bookmarks_activate,0},
       {"xffm/stock_undo",N_("Remove item from frequent"),NULL,"undo_frequent",NULL,NULL,(gpointer)on_undo_history_activate,0},
      {"xffm/stock_undo",N_("Remove item from recent"),NULL,"undo_recent",NULL,NULL,(gpointer)on_undo_history_activate,0},
      {"xffm/stock_undo",N_("Remove item from book"),NULL,"remove_from_bookmarks",NULL,NULL,(gpointer)on_remove_from_bookmarks_activate,0},
      {"xffm/stock_delete",N_("Delete"),NULL,"remove",NULL,NULL,(gpointer)on_remove_activate,0},
      {"xffm/stock_question",N_("Set recent threshold"),NULL,"set_recent_threshold2",NULL,NULL,(gpointer)on_set_recent_threshold_activate,0},

#endif
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };


    
    toggle_button_init_t toggle_columns_info[]={
      {N_("Date"),"date5",(gpointer)toggle_preference,GUINT_TO_POINTER(SHOW_DATE|INDIVIDUAL_TOGGLE)},
      {N_("Size"),"size5",(gpointer)toggle_preference,GUINT_TO_POINTER(SHOW_SIZE|INDIVIDUAL_TOGGLE)},
      {N_("UID"),"uid5",(gpointer)toggle_preference,GUINT_TO_POINTER(SHOW_UID|INDIVIDUAL_TOGGLE)},
      {N_("GID"),"gid5",(gpointer)toggle_preference,GUINT_TO_POINTER(SHOW_GID|INDIVIDUAL_TOGGLE)},
      {N_("Mode"),"mode5",(gpointer)toggle_preference,GUINT_TO_POINTER(SHOW_MODE|INDIVIDUAL_TOGGLE)},
      {NULL,NULL,NULL,NULL}
    };
 

